#include <cassert>
#include "poset.h"

int
main(int argc, char** argv)
{
  mozilla::poset<int> p1;

  assert(!p1.ordered(1, 2));
  p1.order(1, 2);
  assert(p1.ordered(1,2));
  assert(!p1.ordered(2, 1));

  assert(!p1.ordered(2, 3));
  p1.order(2, 3);
  assert(p1.ordered(1, 2));
  assert(p1.ordered(2, 3));
  assert(p1.ordered(1, 3));
  assert(p1.ordered(1, 2));
  assert(!p1.ordered(2, 1));
  assert(!p1.ordered(3, 2));
  assert(!p1.ordered(3, 1));

  p1.remove(2);
  assert(!p1.ordered(1, 2));
  assert(!p1.ordered(2, 3));
  assert(!p1.ordered(1, 3));
  assert(!p1.ordered(2, 1));
  assert(!p1.ordered(3, 2));
  assert(!p1.ordered(3, 1));  

  p1.order(2, 3);
  assert(!p1.ordered(1, 2));
  assert(p1.ordered(2, 3));
  assert(!p1.ordered(1, 3));
  assert(!p1.ordered(2, 1));
  assert(!p1.ordered(3, 2));
  assert(!p1.ordered(3, 1));

  return 0;
}
